% Author : Lei Fu, March. 2015
% is  is   ig   xs   zs   xg   zg   t 
clear;close all ; clc

addpath('~/utility_function/');
%%
fn_coord = 'coord_csg.dat';  % coord 
vtrue_str = 'vel.bin';
rho_str = 'den.bin';
vsmooth_str = 'vsmooth.bin';
refl_str = 'refl.bin';

nz = 122;
nx = 384;
dx = 10; 
dy=dx;


%%

fid = fopen('marmhard.dat','r');
[vel_true0, count] = fscanf(fid,'%f',[nz nx]);
vp = vel_true0(1:51,140:340);
[nz,nx] = size(vp);

rho = 0.31*vp.^(0.25);
% fid = fopen('marmsmooth.dat','r');
% [vel_smooth, count] = fscanf(fid,'%f',[nz nx]);

vp00 = linspace(1600,2700,nz)';
vp0 = repmat(vp00,1,nx);
% [vp0,~] = vel_smooth(vp,9,9,11);

er_v = (vp - vp0);
er = ceil(100*sqrt(sum(er_v(:).^2))/sqrt(sum(vp(:).^2)));

mask = ones(nz,nx);
write_bin('mask_bottom.bin',mask);  


figure
subplot(211)
imagesc(vp)
axis image
subplot(212)
imagesc(vp0)
axis image

refl=zeros(nz,nx);
for i=1:nx
    for j=1:nz-1
        
        refl(j,i) = (vp(j+1,i)-vp0(j,i))/(vp(j+1,i)+vp0(j,i));
    end
end
imagesc(refl)
axis image
%%

write_bin(vtrue_str,vp);
write_bin(rho_str,rho);  
write_bin(vsmooth_str,vp0);    
write_bin(refl_str,refl);  
%%
figure
imagesc((1:nx)*dx,(1:nz)*dx,vp);
axis image;
colorbar
axis([0 nx*dx 0 nz*dy]);

saveas(gca,['model.eps'],'epsc')
print('-dpng','-r300',['model.png']);

%% make coord.dat
t = 0.0 ;
offset = 0;     % shot to the first receiver
xs0 = 0;        % 1st shot x
zs0 = 0;        % 1st shot z
nshot = 40;     % shot number 
dsx = 5*dx;       % shot interval
ntrace = nx/2+1;   % trace number per shot 
drx = 2*dx;       % receiver interval
xg0 = xs0 + offset; 
zg0 = zs0;  


fid = fopen(fn_coord,'wt');
for kk = 1:nshot
    for ii = 1:ntrace
         is = kk;
         ig = ii;
         xs1 = xs0 + (kk-1)*dsx;
         zs = zs0;
         xg = xg0 + (ii-1)*drx;
         zg = zs;
         fprintf(fid,'%d\t%d\t%d\t%f\t%f\t%f\t%f\t%f\n',is,is,ig,xs1,zs,xg,zg,t);        
        
    end
end
fclose(fid)

