clear;close all; clc;

model_dir = 'Marmous_51x201x10';


model = ['/home/ful/PhaInv_SeisF90_Demo/model/2D_models/',model_dir,'/'];

result_dir1 = ['/home/ful/PhaInv_SeisF90_Demo/results/2D_models/',model_dir,'/fwi_ms/'];
result_dir2 = ['/home/ful/PhaInv_SeisF90_Demo/results/2D_models/',model_dir,'/phainv/'];


nz = 51;
nx = 201;
dx = 10;


vtrue = read_bin([model,'vel.bin'],nz,nx);
vp0 = read_bin([model,'vsmooth.bin'],nz,nx);

v1 = read_bin([result_dir1,'vel_39.bin'],nz,nx);
v2 = read_bin([result_dir2,'vel_89.bin'],nz,nx);

%%
xx = (0:nx-1)*dx/1000;
zz = (0:nz-1)*dx/1000;

as1 = 1.500;
as2 = 3.500;
tx = -0.005;
ty = -0.05;

cw = 0.01;
ch = 0.3;
%%
FigHandle = figure('Position', [400, 100, 2000, 900]);

subplot('position',[0.08 0.55 0.35 0.3])
imagesc(xx,zz,vtrue/1000);
caxis([as1 as2])
% axis image
colormap(jet)
% xlabel('X Distance (km)')
ylabel('Depth (km)')
title('True Model','fontsize',12)
set(gca,'fontsize',12)
text(tx,ty,'a)','fontsize',12)
h = colorbar('position',[0.44 0.55 cw ch]);
set(get(h,'title'),'string','km/s');

subplot('position',[0.55 0.55 0.35 0.3])
imagesc(xx,zz,vp0/1000);
caxis([as1 as2])
% axis image
colormap(jet)
% xlabel('X Distance (km)')
% ylabel('Depth (km)')
% title('Initial Model')
title('Initial Model','fontsize',12)
set(gca,'fontsize',12)
text(tx,ty,'b)','fontsize',12)
h = colorbar('position',[0.91 0.55 cw ch]);
set(get(h,'title'),'string','km/s');

subplot('position',[0.08 0.14 0.35 0.3])
imagesc(xx,zz,v1/1000);
caxis([as1 as2])
% axis image
colormap(jet)
xlabel('X Distance (km)')
ylabel('Depth (km)')
% title('FWI Tomogram')
title('FWI Tomogram','fontsize',12)
set(gca,'fontsize',12)
text(tx,ty,'c)','fontsize',12)
h = colorbar('position',[0.44 0.14 cw ch]);
set(get(h,'title'),'string','km/s');

subplot('position',[0.55 0.14 0.35 0.3])
imagesc(xx,zz,v2/1000);
caxis([as1 as2])
% axis image
colormap(jet)
xlabel('X Distance (km)')
% ylabel('Depth (km)')
title('MPI Tomogram ','fontsize',12)
set(gca,'fontsize',12)
text(tx,ty,'d)','fontsize',12)
h = colorbar('position',[0.91 0.14 cw ch]);
set(get(h,'title'),'string','km/s');

saveas(gca,[result_dir2,'../phainv_tomogram.eps'],'epsc')
print('-dpng','-r300',[result_dir2,'../phainv_tomogram.png']);



